--装备穿戴/更换
checkRequire("Lua_EquipBaesAttrItem");
Lua_EquipChangeWindow = class("Lua_EquipChangeWindow", Lua_Window);
function Lua_EquipChangeWindow:ctor()
    self:superCall("ctor");
    self.showClose = false;
    self.windowName = "Lua_EquipChangeWindow";
    self.skinName="EquipChangeWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_EquipChangeWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.dic1.text = LanUtil.getValue(126748);
    self.dic2.text = LanUtil.getValue(126749);

    self.itemIcon = Lua_ItemIcon.new(self.showObj);
    self.itemIcon:setLocation(-238, 0, 0);
    self.itemIcon:setCanClick(true);

    self.dragList = Lua_DragList.new(self.content,631, 558, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_EquipChangeCell, 631, 140, 1);
    self.dragList:setCellSpacing(2, 2);
    self.dragList:setLocation(0, -146);

    self.dic3:addClickFuntion(self, self.gotoWFunction);
    self.demount_btn:addClickFuntion(self, self.onSubBtnClick);
    -- self:addLuaEvent("UPDATE_ONE_EQUIP_INFO", self, self.updateChangeInfo);
    self:addLuaEvent("CHANGE_SELECT_EQUIP", self, self.selectEquip);--穿戴装备
end

function Lua_EquipChangeWindow:showWin(param)
    -- param.part --部位
    -- param.data --装备vo
    -- param.hero_uid--英雄唯一id
    --print(param.part,param.data,param.hero_uid);
    self.hero_uid = param.hero_uid;--英雄唯一id
	if param.data == nil then
        self.equip_uid = nil;
		self.part = param.part;
	else
        self.equip_uid = param.data.unique_id;
		self.part = param.data.part;
        -- self.data = param.data;--装备vo

        self.itemIcon:setData(param.data);
        self.itemIcon:showNum(0);

        self.name.text = param.data.name;
        self.socre.text = param.data.score;
        --self:showAttr(param.data);
	end

    self.showObj:SetActive(param.data ~= nil);
    self.showObj1:SetActive(param.data == nil);

    local arr = DataCenter.equipData:getEquipPartInfo(self.part, self.equip_uid);
    self.dragList:setArrayData(arr);
    self.dragList:setEnable(arr:getSize() > 0);
    self.showObj2:SetActive(arr:getSize() <= 0);
end

-- 基础属性
function Lua_EquipChangeWindow:showAttr(data)
    local item;
    local arr = DataCenter.attributesUtil:getAttrArrByServer(data.property);
    if self.showAttrInfo == nil then
        self.showAttrInfo = Array();
    end
    for i=1,arr:getSize() do
        if self.showAttrInfo[i] ~= nil then
            item =self.showAttrInfo[i];
        else
            item = Lua_EquipBaesAttrItem.new(self.showObj);
        end
        item:setShowData(arr[i], data.addPercent);
        item:setLocation(-140 + (i-1)*142, -28,0);
        self.showAttrInfo:add(item);
    end
end

function Lua_EquipChangeWindow:onSubBtnClick()
    Lua_ProxyManager.getProxy("Lua_EquipProxy"):sDemountEquip(self.hero_uid, self.equip_uid);
    self:hide();
end

function Lua_EquipChangeWindow:selectEquip(equip_vo)
    Lua_ProxyManager.getProxy("Lua_EquipProxy"):sWornEquip(self.hero_uid, equip_vo.unique_id, equip_vo.hero_uid);
    self:hide();
end

--跳转
function Lua_EquipChangeWindow:gotoWFunction()
    DataCenter.funcPathUtil:gotoFunction(DataCenter.equipUtil.go_to_id, true);
end


function Lua_EquipChangeWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.showAttrInfo ~= nil then
        self.showAttrInfo:dispose();
        self.showAttrInfo:clear();
        self.showAttrInfo = nil;
    end
    self:superCall("dispose");
end



















Lua_EquipChangeCell = class("Lua_EquipChangeCell", Lua_ListCell);
function Lua_EquipChangeCell:ctor(p)
    self:superCall("ctor", p, "EquipChangeCell_skin");
end

function Lua_EquipChangeCell:buildShowItem()
    self:superCall("buildShowItem");
    self.icon_bj:setAltas("common_altas_3", "xui_common_widget_019");
    self.icon:setScale(0.55, 0.55, 1);

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(-237, 0, 0);
    self.itemIcon:setCanClick(true);

    self.change_btn:addClickFuntion(self, self.onChangeBtnClick);
end

function Lua_EquipChangeCell:setData(uid)
	self.data  = DataCenter.equipData:getEquipVoByUid(uid);
	self.name.text = self.data.name;
	self.socre.text = self.data.score;
    if self.data.hero_uid ~= 0 then --已被穿戴
        self.dic:setEnable(true);
        self.icon:setEnable(true);
        self.icon_bj:setEnable(true);
        self.change_btn:setStyle(1);
        self.change_btn.txt.colorStr = Lua_ColorDefine.transColorStr("8B5E34");
        self.change_btn:setLangValue(126712);
        local hvo = DataCenter.heroData:getItemByUniqueId(self.data.hero_uid);
        self.icon:setAltas(hvo.avatar_atlas_1, hvo.avatar_sprite_1);
    else
        self.dic:setEnable(false);
        self.icon:setEnable(false);
        self.icon_bj:setEnable(false);
        self.change_btn:setStyle(3);
        self.change_btn.txt.colorStr = Lua_ColorDefine.transColorStr("7A6A5F");
        self.change_btn:setLangValue(126700);
    end
    self.itemIcon:setData(self.data);
    self.itemIcon:showNum(0);

    --self:showAttr(self.data);
end

-- 基础属性
function Lua_EquipChangeCell:showAttr(data)
    local arr = DataCenter.attributesUtil:getAttrArrByServer(data.property);
    local item;
    if self.showAttrInfo == nil then
        self.showAttrInfo = Array();
    end
    for i=1,arr:getSize() do
        if self.showAttrInfo[i] ~= nil then
            item =self.showAttrInfo[i];
        else
            item = Lua_EquipBaesAttrItem.new(self.content);
            item:setRectAnchor(9);
            item:setRectPivot(0);
        end
        item:setShowData(arr[i], data.addPercent);
        item:setLocation(-140 + (i-1)*142, -28, 0);
        self.showAttrInfo:add(item);
    end
end

function Lua_EquipChangeCell:onChangeBtnClick()
	Lua_MsgUtil.callFunc("CHANGE_SELECT_EQUIP", self.data);
end

function Lua_EquipChangeCell:dispose()
    self.data = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.showAttrInfo ~= nil then
        self.showAttrInfo:dispose();
        self.showAttrInfo:clear();
        self.showAttrInfo = nil;
    end
    self:superCall("dispose");
end