--装备tips
Lua_EquipTipsWindow = class("Lua_EquipTipsWindow", Lua_Window);
function Lua_EquipTipsWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_EquipTipsWindow";
    self.skinName = "EquipTipsWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_EquipTipsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.starBgH = 306;--背景初始高度
    self.bgHight = 643;--背景总高度
    self.recast_btn:addClickFuntion(self, self.onRecastBtnClick);--重铸

    self:addLuaEvent("UPDATE_ONE_EQUIP_INFO", self, self.updateTipsInfo);
end

function Lua_EquipTipsWindow:dispose()
    if self.baseAttrInfo ~= nil then
        self.baseAttrInfo:dispose();
        self.baseAttrInfo:clear();
        self.baseAttrInfo = nil;
    end
    if self.suitInfo ~= nil then
        self.suitInfo:dispose();
        self.suitInfo:clear();
        self.suitInfo = nil;
    end
    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
    if self.btnArr ~= nil then
        self.btnArr:dispose();
        self.btnArr:clear();
        self.btnArr = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_EquipTipsWindow:showWin(param)
	self:superCall("showWin",param);
	self.data = param.data;

	self.isShowBtns = param.isShowBtns;
	local list;
	if self.data.hero_uid ~= 0 then --英雄打开
		self.hero_uid = param.hero_uid;
		if self.isShowBtns then
			list = {11, 9, 10}; -- 替换 卸下 锻造
		end
	else -- 背包打开
		list = self.data.buttonList;
		if list == nil or #list <= 0 then
			self.isShowBtns = false;
		end
	end
	local height = self:showButtonList(list);
	self.intHeight = self.starBgH + height;
	self.downObj:SetActive(self.isShowBtns);
	self.recast_lab:setEnable(self.isShowBtns);
	self.recast_btn:setEnable(self.isShowBtns);

	self.des.text = self.data.des;
	self.name.text = self.data.name;
	self.socre.text = self.data.score;
	self.type_name.text = DataCenter.equipUtil:getEquipPartConfigInfo(self.data.part).name;

	self:showStar(self.data.star);
	self:updateTipsInfo(self.data);--更新Tips
end

-- 更新
function Lua_EquipTipsWindow:updateTipsInfo(val)
	if type(val) == "number" then
		if val == self.data.unique_id then
			data = DataCenter.equipData:getEquipVoByUid(val);
		end
	else
		data = val;
	end

	self.icon:setAltas(data.atlas, data.sprite);
	self.winBg:setAltas("common_altas_2", "ui_common_window_0"..16+data.color);

	--种族显示处理
	self.showBgH = self.intHeight;
	if data.isServerRace == true then
		self.raceObj:SetActive(true);
		self.raceAttrObj:SetActive(true);
		LuaUtil.setObjPos(self.suitObj, 0, 0, 0);

		
		local show_str;
		local campName = LanUtil.getValue(126050 + data.race_camp);
		if data.isActiviteRace == true then
			show_str = LanUtil.formateStr(126743,campName, tostring(data.prop_add));
		else
			show_str = LanUtil.formateStr(126744,campName, tostring(data.prop_add));
		end
		self.race_des.text  = show_str;
		self.showBgH = self.showBgH + self.race_des.height + 65;
		self.type_icon:setAltas("common_altas_2", "ui_common_icon_"..(data.race_camp+22));
		self.camp:setAltas("common_altas_2", "ui_common_button_0"..(data.race_camp+25).."_n");
	else
		if data.isCfgRace == true then--有配置种族
			self.raceObj:SetActive(true);
			self.raceAttrObj:SetActive(true);
			self.recast_btn:setEnable(false);
			self.recast_lab:setEnable(false);
			LuaUtil.setObjPos(self.suitObj, 0, 0, 0);

			if data.cfgRace == 999 then--随机种族
				self.camp:setAltas("common_altas_2", "ui_common_button_054_n");
				self.type_icon:setAltas("common_altas_2", "ui_common_button_054_n");
			else--固定种族
				self.type_icon:setAltas("common_altas_2", "ui_common_icon_"..(data.cfgRace+22));
				self.camp:setAltas("common_altas_2", "ui_common_button_0"..(data.cfgRace+25).."_n");
			end
			self.camp:resetSize();
			self.type_icon:resetSize();

			self.race_des.text  = LanUtil.getValue(126747);
			self.race_des:resetSize();
			self.showBgH = self.showBgH + self.race_des.height + 65;
			LuaUtil.setObjPos(self.suitObj, 0, -28, 0);
		else
			self.raceObj:SetActive(false);
			self.raceAttrObj:SetActive(false);
			LuaUtil.setObjPos(self.suitObj, 0, 94, 0);
		end
	end

   	local suit_id = data.color*1000 + data.star*100 + 2;
	local isShowSuit = DataCenter.equipUtil:isShowSuit(suit_id);--是否有套装
	self.suitObj:SetActive(isShowSuit);
	if isShowSuit == true then
		self.showBgH = self.showBgH + 158;--有套装背景增加163高度
	end
	self:showSuitAttr(isShowSuit);

    self.winBg:SetDimensions(544, self.showBgH);
    LuaUtil.setObjPos(self.downObj, 0, self.bgHight/2 - self.winBg.height + 39.5, 0);

    if self.hero_uid ~= nil and self.isShowBtns == true then
    	local heroVo = DataCenter.heroData:getItemByUniqueId(self.hero_uid);--上阵英雄展示锻造红点
	    --锻造红点状态
	    local showState = DataCenter.equipData:checkEquipForgeRedDot(data);
	    self:showRedDot(showState and heroVo.isShowFight == true);
	end
	self:showBaseAttr(data);
end

--锻造红点
function Lua_EquipTipsWindow:showRedDot(val)
    if val == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:setLocation(64, self.bgHight/2 - self.winBg.height + 39.5 - 32, 0);
            self.redDotIcon:createRedPointImg(nil);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

-- 基础属性
function Lua_EquipTipsWindow:showBaseAttr(data)
	local arr = DataCenter.attributesUtil:getAttrArrByServer(data.property);
	local isServerInfo = true;--是否是服务端数据
	if arr:getSize() == 0 then
		isServerInfo = false;
		arr = DataCenter.equipUtil:getEquipAttrInfo(data.equipPropId, data.attr_list);
	end
	if self.baseAttrInfo == nil then
        self.baseAttrInfo = Array();
    end
    local len = self.baseAttrInfo:getSize();
    for i = 1, len do
        self.baseAttrInfo[i]:setEnable(false);
    end

    local item;
	for i = 1,arr:getSize() do
        if self.baseAttrInfo[i] ~= nil then
            item = self.baseAttrInfo[i];
        else
            item = Lua_EquipTipsAttrItem.new(self.baseObj);
            self.baseAttrInfo:add(item);
        end
        item:setData(arr[i], data, isServerInfo);
		item:setLocation(-235 + ( i - 1) * 302, 12 ,0);
		item:setEnable(true);
	end
end

-- 套装效果
function Lua_EquipTipsWindow:showSuitAttr(bool)
	if bool == false then
		return;
	end
	if self.suitInfo == nil then
		self.suitInfo = Array();
	end
	local info = self.data.suitInfo;
	if info ~= nil and info:getSize() > 1 then
		info:sort("sort", false);
	end
	local item;
	for i = 1, 3 do
		item = self.suitInfo[i];
		if item == nil then
			item = Lua_EquipSuitAttrItem.new(self.suitObj);
			self.suitInfo:add(item);
			item:setIndex(i);--索引
		end
		item:setSuitId(self.data.color*1000 + self.data.star*100 + i +1);--未激活套装id
		item:setData(info);--套装数据
		item:setLocation(-247,-174 - (i-1)*37,0);
	end
end

-- 显示星
function Lua_EquipTipsWindow:showStar(star)
	if star ~= nil and star > 0 then
		local showStar = DataCenter.heroUtil:getShowStar(star);
		if self.starArr == nil then
            self.starArr = Array();
        end
        local len = self.starArr:getSize();
        local spr = DataCenter.heroUtil:getStarSprite(star, 3);
        local starWidth = 15;
        local num = len;
        if len < showStar then
            num = showStar;
        end
        for i = 1, num do
            local item = self.starArr[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.upObj, "common_altas_1", "ui_common_label_011", 0, 0, 26, 27);
                self.starArr:add(item);
            else
                item:setEnable(i <= showStar);
            end
            item:setLocation(-1 * starWidth * showStar / 2 + starWidth * (i-1) + starWidth / 2-197.5, 168, 0);
            item:setAltas("common_altas_1", spr);
        end
	else
		if self.starArr ~= nil then
            local len = self.starArr:getSize();
            for i = 1, len do
                self.starArr[i]:setEnable(false);
            end
        end
	end
end

function Lua_EquipTipsWindow:showButtonList(list)
    if not self.isShowBtns then
        return 0;
    end

    if self.btnArr == nil then
        self.btnArr = Array();
    end
    local arr = Array();
    local obj;
	if list ~= nil then
	    for i = 1, #list do
	        obj = list[i];
	        if self.data.expired_tick ~= nil and self.data.expired_tick > 0 then
	            if self.data.isExpired then
	                if obj == 4 then
	                    arr:add(obj);
	                end
	            else
	                if obj ~= 4 then
	                    arr:add(obj);
	                end
	            end
	        else
	            arr:add(obj);
	        end
	    end
	end

    local num = arr:getSize();
    local len = self.btnArr:getSize();
    local maxLen = num > len and num or len;
    local btn;

    local startX;
    local intervalX;
    local intervalY = -66;
    local count;
    if num == 1 then
        startX = 0;
        intervalX = 0;
        count = 1;
    elseif num == 2 then
        startX = -138;
        intervalX = 276;
        count = 2;
    elseif num == 3 then
        startX = -172;
        intervalX = 172;
        count = 3;
    elseif num == 4 then
        startX = -138;
        intervalX = 276;
        count = 2;
    elseif num == 5 then
        startX = -172;
        intervalX = 172;
        count = 3;
    elseif num == 6 then
        startX = -172;
        intervalX = 172;
        count = 3;
    end    

    local posX;
    local posY;
    for i = 1, maxLen do
        btn = self.btnArr[i];
        if i > num then
            if btn ~= nil then
                btn:setEnable(false);
            end
        else
            if btn == nil then
                btn = UICreate.createButton(self.downObj, nil, 0, 0, 156, 51);
                btn:setStyle(11);
                btn.txt:setLocation(0, 0, 0);
                btn.txt.fontSize = 27;
                btn.txt.colorStr = Lua_ColorDefine.transColorStr("3D424F");
                self.btnArr:add(btn);
            else
                btn:setEnable(true);
            end
            
			if arr[i] == 10 then
				btn:setLangValue(309065);
			elseif arr[i] == 11 then
				btn:setLangValue(309066);
			else
				btn:setLangValue(309010 + arr[i]);
			end
			btn.name = tostring(arr[i]);
            posX = startX + ((i - 1) % count) * intervalX;
            posY = -49 + Mathf.Floor((i - 1) / count) * intervalY;
            if num == 5 and i == num then
                posX = posX + intervalX;
            end
            btn:setLocation(posX, posY, 0);
            btn:addClickFuntion(self, self.onButtonClick);
        end
    end

    if num < 4 then
        return 82;
    end
    return 160;
end

function Lua_EquipTipsWindow:onButtonClick(go)
	if tonumber(go.name) == 6 then -- 穿戴
		DataCenter.funcPathUtil:gotoFunction(1033, true);
	elseif tonumber(go.name) == 9 then -- 锻造
		Lua_WindowUtil.openWin("Lua_EquipForgeWindow", Lua_WinParam.ACTION_OPEN, self.data);
	elseif tonumber(go.name) == 10 then -- 替换
		Lua_WindowUtil.openWin("Lua_EquipChangeWindow", Lua_WinParam.ACTION_OPEN, {data = self.data, hero_uid = self.hero_uid});
	elseif tonumber(go.name) == 11 then -- 卸下
		Lua_ProxyManager.getProxy("Lua_EquipProxy"):sDemountEquip(self.hero_uid, self.data.unique_id);
	end
	self:hide();
end

--重铸
function Lua_EquipTipsWindow:onRecastBtnClick()
	Lua_WindowUtil.openWin("Lua_EquipRecastWindow", Lua_WinParam.ACTION_OPEN, self.data.unique_id);
end

































--装备基础属性
Lua_EquipTipsAttrItem = class("Lua_EquipTipsAttrItem", Lua_DisplayObject);
function Lua_EquipTipsAttrItem:ctor(p)
    self:superCall("ctor", p, "EquipTipsAttrItem_skin");
end

function Lua_EquipTipsAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_EquipTipsAttrItem:setData(att_vo, data, isServerInfo)
	local show_str = "";
	if att_vo.isPercent == 0 then --基础属性
		if data ~= nil and data.isActiviteRace then --种族激活
			if isServerInfo == true then
				local base_value = att_vo.value/(1+data.prop_add/100);
				show_str = base_value.."<color=#37d652> +"..Mathf.Floor(att_vo.value - base_value +0.5).."</color>";
			else
				local add_value = att_vo.value * (data.prop_add/100);
				show_str = att_vo.value.."<color=#37d652> +"..Mathf.Floor(add_value + 0.5).."</color>";
			end
		else
			show_str = att_vo.showValue;
		end
	else
		show_str = att_vo.showValue;
	end
	self.des.text = "<color=#c1bdb6>"..att_vo.show_name.."：</color>"..show_str;
	self.icon:setAltas("common_altas_2",att_vo.attr_icon_2);
end

function Lua_EquipTipsAttrItem:dispose()
	self:superCall("dispose");
end

























--套装属性
Lua_EquipSuitAttrItem = class("Lua_EquipSuitAttrItem", Lua_DisplayObject);
function Lua_EquipSuitAttrItem:ctor(p)
    self:superCall("ctor", p,"EquipSuitAttrItem_skin");
end

function Lua_EquipSuitAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_EquipSuitAttrItem:setIndex(val)
	self.index = val;
	self.show_des = LanUtil.getValue(126734 + val);
end

function Lua_EquipSuitAttrItem:setSuitId(val)
	self.suit_id = val;
end

function Lua_EquipSuitAttrItem:setData(info)
    local data;
    if info ~= nil then
    	data = info[self.index];
    end

    local show_str = "";
	if data == nil then--没套装
		local show_des = self.show_des..self:getDesc(self.suit_id).."："..self:getAttrDesc(self.suit_id);
		show_str = Lua_ColorDefine.getColorStr("737373",show_des);
	else
		local suit_id = data.suit_id;--已激活的套装id
		local suit_vo = DataCenter.equipUtil:getEquipSuitInfo(suit_id);
		if suit_vo ~= nil then
			local show_color = suit_vo.color;
			show_str = self.show_des.."<color=#"..Lua_ColorDefine.getItemColorStr(show_color)..">"..self:getDesc(suit_id).."</color>".."：<color=#37d652>"..self:getAttrDesc(suit_id).."</color>";
		end
	end
	self.attr_des.text = show_str;
end

-- 配置描述
function Lua_EquipSuitAttrItem:getDesc(suit_id)
	--配置描述
	local suit_vo = DataCenter.equipUtil:getEquipSuitInfo(suit_id);
	if suit_vo ~= nil then
		return suit_vo.desc;
	end
	return "";
end

-- 配置属性描述
function Lua_EquipSuitAttrItem:getAttrDesc(suit_id)
	local suit_vo = DataCenter.equipUtil:getEquipSuitInfo(suit_id);
	if suit_vo ~= nil then
		local str = "";
		local attr_vo;
		local attr_value;
		local attr_list = suit_vo.attr_list;
	    for i=1,#attr_list do
	    	attr_value = getConfig({ "equip_suit", suit_id, attr_list[i]});
	    	attr_vo = DataCenter.attributesUtil:createAttrVo(attr_list[i]);
	    	if attr_vo.isPercent == 1 then
	    		attr_value = (attr_value * 100) .. "%";
	    	end
	    	str = str..attr_vo.show_name.." +"..attr_value;
	    end
	    return str;
	end

	return "";
end

function Lua_EquipSuitAttrItem:dispose()
	self:superCall("dispose");
end