--符石穿戴/更换
Lua_RunesChangeWindow = class("Lua_RunesChangeWindow", Lua_Window);
function Lua_RunesChangeWindow:ctor()
    self:superCall("ctor");
    
    self.windowName = "Lua_RunesChangeWindow";
    self.skinName = "RunesChangeWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_RunesChangeWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.dic1.text = LanUtil.getValue(126856);
    self.dic2.text = LanUtil.getValue(126857);

    self.itemIcon = Lua_ItemIcon.new(self.showObj);
    self.itemIcon:setLocation(-250, 0, 0);
    self.itemIcon:setCanClick(true);

    self.dragList = Lua_DragList.new(self.content,630, 575, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_RunesChangeCell, 630, 155, 1);
    self.dragList:setCellSpacing(0, 5);
    self.dragList:setLocation(0, -110);

    self.go_dic:addClickFuntion(self, self.onCheckPath);
    self.demount_btn:addClickFuntion(self, self.onSubBtnClick);
    self:addLuaEvent("CHANGE_SELECT_RUNES", self, self.selectRunes);--穿戴符石

    Lua_WindowUtil.openWin("Lua_RunesTipsWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_RunesChangeWindow:showWin(param)
    -- param.part; --部位
    -- param.data; --符文数据
    -- param.hero_uid;--英雄唯一id
    self.part = param.part;
    self.hero_uid = param.hero_uid;

	if param.data == nil then
        self.arr = param.arr;
	else    
        self.itemIcon:setData(param.data);
        self.name.text = param.data.colorName;
        self.socre.text = LanUtil.formateStr(126844, tostring(param.data.score));
        
        self:showBaseAttr(param.data.cur_prop);
        self:showSkillName(param.data.rune_skill_list);
	end
    
    local hvo = DataCenter.heroData:getItemByUniqueId(param.hero_uid);
    local arr = DataCenter.runesData:getRunesChangeInfo(hvo.runsInfo[1], hvo.runsInfo[2]);
    self.showObj:SetActive(param.data ~= nil);
    self.showObj1:SetActive(param.data == nil);

    self.dragList:setArrayData(arr);
    self.showObj2:SetActive(arr:getSize() <= 0);
end

-- 基础属性
function Lua_RunesChangeWindow:showBaseAttr(list)
    local arr = DataCenter.attributesUtil:getAttrArrByServer(list);
    local item;
    self.baseAttrInfo = Array();
    for i=1,arr:getSize() do
        item = Lua_RunesChangeAttrItem.new(self.showObj);
        item:setData(arr[i]);
        item:setLocation(-163 + (i-1)*167, -2, 0);
        self.baseAttrInfo:add(item);
    end
end

-- 技能名字
function Lua_RunesChangeWindow:showSkillName(list)
    local item;
    self.showSkillInfo = Array();
    for i=1,#list do
        item = Lua_RunesSkillNameItem.new(self.showObj);
        item:setData(list[i]);
        item:setLocation(-174 + (i-1)*168, -18, 0);
        self.showSkillInfo:add(item);
    end
end

function Lua_RunesChangeWindow:onCheckPath(go)
    DataCenter.packUtil:openPathWindow(Lua_PackDefine.PRIMARY_RUNES, false);
end

--卸下符石
function Lua_RunesChangeWindow:onSubBtnClick()
    Lua_ProxyManager.getProxy("Lua_RunesProxy"):sDemountRunes(self.hero_uid, self.part);
    self:hide();
end

--穿戴符石
function Lua_RunesChangeWindow:selectRunes(runesVo)
    Lua_ProxyManager.getProxy("Lua_RunesProxy"):sWornRunes(self.hero_uid, self.part, runesVo.unique_id, runesVo.hero_uid);
    self:hide();
end

function Lua_RunesChangeWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end

    if self.baseAttrInfo ~= nil then
        self.baseAttrInfo:dispose();
        self.baseAttrInfo:clear();
        self.baseAttrInfo = nil;
    end
    if self.showSkillInfo ~= nil then
        self.showSkillInfo:dispose();
        self.showSkillInfo:clear();
        self.showSkillInfo = nil;
    end

    self.data = nil;
    self:superCall("dispose");
end



















Lua_RunesChangeCell = class("Lua_RunesChangeCell", Lua_ListCell);
function Lua_RunesChangeCell:ctor(p)
    self:superCall("ctor", p, "RunesChangeCell_skin");
end

function Lua_RunesChangeCell:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(-237, 0, 0);
    self.itemIcon:setCanClick(true);

    self.avatarBg = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_widget_019", 0, 0, 0, 0);
    self.avatarBg:setScale(0.3, 0.3, 1);

    self.avatarIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
    self.avatarIcon:setScale(0.27, 0.27, 1);

    self.change_btn:addClickFuntion(self, self.onChangeBtnClick);
end

function Lua_RunesChangeCell:setData(uid)
	self.data = DataCenter.runesData:getRunesVoByUid(uid);

	self.name.text = self.data.colorName;
	self.socre.text = LanUtil.formateStr(126844, tostring(self.data.score));
    self.itemIcon:setData(self.data);

    self:setWearTips();
    self:showBaseAttr(self.data.cur_prop);
    self:showSkillName(self.data.rune_skill_list);
end

function Lua_RunesChangeCell:setWearTips()
    if self.data.hero_uid ~= 0 then --已被穿戴
        self.change_btn:setLangValue(126712);
        local heroVo = DataCenter.heroData:getItemByUniqueId(self.data.hero_uid);
        self.promptText:setEnable(true);
        self.promptText.text = LanUtil.formateStr(126745, heroVo.name);
        self.promptText:resetSize();

        self.avatarBg:setEnable(true);
        self.avatarIcon:setEnable(true);
        self.avatarBg:setLocation(self.promptText.posX - self.promptText.width - 20, -46.5, 0);
        self.avatarIcon:setLocation(self.promptText.posX - self.promptText.width - 20, -46.5, 0);
        self.avatarIcon:setAltas(heroVo.avatar_atlas_1, heroVo.avatar_sprite_1);
    else
        self.change_btn:setLangValue(126700);
        self.promptText:setEnable(false);
        self.avatarBg:setEnable(false);
        self.avatarIcon:setEnable(false);
    end
end

-- 基础属性
function Lua_RunesChangeCell:showBaseAttr(list)
    local arr = DataCenter.attributesUtil:getAttrArrByServer(list);
    local item;
    if self.baseAttrInfo == nil then
        self.baseAttrInfo = Array();
    end
    local len1 = self.baseAttrInfo:getSize();
    for i = 1, len1 do
        self.baseAttrInfo[i]:setEnable(false);
    end
    for i = 1, arr:getSize() do
        if self.baseAttrInfo[i] ~= nil then
            item = self.baseAttrInfo[i];
        else
            item = Lua_RunesChangeAttrItem.new(self.content);
            self.baseAttrInfo:add(item);
        end
        item:setData(arr[i]);
        item:setLocation(-163 + (i-1)*167, -5,0);
        item:setEnable(true);
    end
end

-- 技能名字
function Lua_RunesChangeCell:showSkillName(list)
    if self.showSkillInfo == nil then
        self.showSkillInfo = Array();
    end
    local len1 = self.showSkillInfo:getSize();
    for i = 1, len1 do
        self.showSkillInfo[i]:setEnable(false);
    end
    local item;
    for i = 1, #list do
        if self.showSkillInfo[i] ~= nil then
            item = self.showSkillInfo[i];
        else
            item = Lua_RunesSkillNameItem.new(self.content);
            self.showSkillInfo:add(item);
        end
        item:setData(list[i]);
        item:setLocation(-174 + (i-1)*168, -21,0);
        item:setEnable(true);
    end
end

function Lua_RunesChangeCell:onChangeBtnClick()
	Lua_MsgUtil.callFunc("CHANGE_SELECT_RUNES", self.data);
end

function Lua_RunesChangeCell:dispose()
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.wearHero ~= nil then
        self.wearHero:dispose();
        self.wearHero = nil;
    end
    if self.baseAttrInfo ~= nil then
        self.baseAttrInfo:dispose();
        self.baseAttrInfo:clear();
        self.baseAttrInfo = nil;
    end
    if self.showSkillInfo ~= nil then
        self.showSkillInfo:dispose();
        self.showSkillInfo:clear();
        self.showSkillInfo = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end









--装备基础属性
Lua_RunesChangeAttrItem = class("Lua_RunesChangeAttrItem", Lua_DisplayObject);
function Lua_RunesChangeAttrItem:ctor(p)
    self:superCall("ctor", p, "RunesChangeAttrItem_skin");
end

function Lua_RunesChangeAttrItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_RunesChangeAttrItem:setData(att_vo)
    self.des.text = att_vo.show_name.."+"..att_vo.showValue;
    self.icon:setAltas("common_altas_2",att_vo.attr_icon_2);
end

function Lua_RunesChangeAttrItem:dispose()
    self:superCall("dispose");
end













--符石技能名字
Lua_RunesSkillNameItem = class("Lua_RunesSkillNameItem", Lua_DisplayObject);
function Lua_RunesSkillNameItem:ctor(p)
    self:superCall("ctor", p,"RunesSkillNameItem_skin");
end

function Lua_RunesSkillNameItem:buildShowItem()
    self:superCall("buildShowItem");
    self.name:addClickFuntion(self, self.onBtnClick);
end

function Lua_RunesSkillNameItem:setData(id)
    self.skill_vo = Lua_SkillConfigData.getConfigData(id);
    if self.skill_vo == nil then
        return;
    end
    self.name.text = "<u>"..self.skill_vo.name.."</u>";
end

function Lua_RunesSkillNameItem:onBtnClick()
    if self.skill_vo == nil then
        return;
    end
    Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN,self.skill_vo);
end

function Lua_RunesSkillNameItem:dispose()
    self:superCall("dispose");
end