--符石合成
Lua_RunesCompoundWindow = class("Lua_RunesCompoundWindow", Lua_Window);
function Lua_RunesCompoundWindow:ctor()
    self:superCall("ctor");

    self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
    self.isFullSizeWin = true;
    self.showBackBtn = true;
    self.windowName = "Lua_RunesCompoundWindow";
    self.skinName = "RunesCompoundWindow_skin";
end

function Lua_RunesCompoundWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.backBtn:setLocation(77, 54, 0);
    self.showBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 60.5, 720, 121);
    self.showBg.anchor = Lua_WindowUtil.getAnchor(7);
    self.showBg.siblingIndex = 1;

    self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content);
    self.roleInfoPanel:setRectAnchor(1);

    self.cost_obj:SetActive(false);
    
    self.showTips:setLangValue(126823);
    local vo = DataCenter.runesUtil.smelt_reward_vo;
    self.smelt_tips.text = LanUtil.formateStr(126824, tostring(DataCenter.runesUtil.smelt_value), vo.colorStr, vo.name);

    local pos = {{-215, 4}, {-275, 196}, {-203, 395}, {4, 481}, {207, 399}};
    self.showRunesArr = Array();
    local item;
    for i=1, 5 do
        item = Lua_RunesCompoundItem.new(self.content);
        item.index = i;
        item:setLocation(pos[i][1], pos[i][2]);
        self.showRunesArr:add(item);
    end

    self.help:addClickFuntion(self, self.onHelpClick);
    self.oneAdd_btn:addClickFuntion(self, self.onOneAddBtnClick);--一键添加
    self.skill_btn:addClickFuntion(self, self.onShowSkillBtnClick);  -- 技能展示
    self.compound_btn:addClickFuntion(self, self.onCompoundBtnClick);-- 合成

    self.sub:addClickFuntion(self, self.onSubBtnClick);--减
    self.add:addClickFuntion(self, self.onAddBtnClick);--加
    self.smelt_bg:addClickFuntion(self, self.onSmeltBtnClick);--熔炼奖励

    self.showPutNum = DataCenter.runesData.showPutNum;
    self:updatePutNum(self.showPutNum);
    self:showCompoundInfo();
    self:addLuaEvent("SRUNES_COMPOUND", self, self.showCompoundInfo); -- 合成返回
    self:addLuaEvent("ON_SELECT_COMPOUND_ITEM", self, self.onCompoundCostWindow);
    self:addLuaEvent("UPDATE_COST_SELECT_INFO", self, self.updateCostSelectInfo);--材料选择返回数据

    self:addLuaEvent("MONEY_UPDATE", self, self.showCompoundInfo);--熔炼值改变更新数据

    Lua_WindowUtil.openWin("Lua_RunesTipsWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_PackWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_RunesCompoundWindow:dispose()
    if self.roleInfoPanel ~= nil then
        self.roleInfoPanel:dispose();
        self.roleInfoPanel = nil;
    end
    if self.showRunesArr ~= nil then
        self.showRunesArr:dispose();
        self.showRunesArr:clear();
        self.showRunesArr = nil;
    end

    if self.redPoint ~= nil then
        self.redPoint:dispose();
        self.redPoint = nil;
    end

    self.selectRunesUidDic = nil;
    self:superCall("dispose");
end

function Lua_RunesCompoundWindow:showCompoundInfo()
    self.selectRunesUidDic = {};
    self.isHaveMoney = nil;
    local id = DataCenter.runesUtil.smelt_id;
    local num = DataCenter.packData:getItemCountById(id);
    local maxNum = DataCenter.runesUtil.smelt_value;
    self.smelt_num.text = num;
    
    self.smeltBar:setMaxValue(maxNum);
    self.smeltBar:setValue(num);
    -- self.smeltBar:setText(num.."/"..maxNum);
    if num >= maxNum then
        if self.redPoint == nil then
            self.redPoint = Lua_RedPointIcon.new(self.content);
            self.redPoint:setLocation(-220, -320, 0);
            self.redPoint:createRedPointEff();
        end
        self.redPoint:updateRedPointShow(true);        
    else
        if self.redPoint ~= nil then
            self.redPoint:updateRedPointShow(false);
        end
    end
    
    self:updateShowCompound(self.selectRunesUidDic);
end

--材料选择更新合成展示
function Lua_RunesCompoundWindow:updateShowCompound(list)
    self.selectRunesUidDic = list;
    local uid;
    local num = 0;
    local index = 0;
    local _lits = {};
    for k,v in pairs(list) do
        index = index+1;
        _lits[index] = k;
        uid = k;
    end
    for i=1, self.showRunesArr:getSize() do
        self.showRunesArr[i]:setData(_lits[i]);
    end
    self.isHaveMoney = nil;
    if uid ~= nil then
        local r_vo = DataCenter.runesData:getRunesVoByUid(uid);
        self.compoundVo = Lua_RunesVo.new(r_vo.next_item_id);
        self.icon_add:setEnable(false);
        self.icon_bg:setAltas("runes_atlas", "ui_fs_itembg_0"..self.compoundVo.color + 3);
        self.icon_bg.mouseEnable = true;
        self.icon_bg:addClickFuntion(self, self.onCheckCompound);
        self.icon:setEnable(true);
        self.icon:setAltas(self.compoundVo.atlas, self.compoundVo.sprite);

        if index < DataCenter.runesUtil.put_runes_min then
            self.cost_obj:SetActive(false);
            self.succeed_tips:setLangValue(126822);
        else
            self.cost_obj:SetActive(true);

            local succeed = DataCenter.runesData:getSucceedNum(r_vo.compose_rate,index);
            local color;
            if succeed <= 0.4 then
                color = "EB5959";
            elseif succeed > 0.4 and succeed < 0.8  then
                color = "FFDD5E";
            else
                color = "C8FF59";
            end
            self.succeed_tips.text = LanUtil.formateStr(126828, "<color=#"..color..">"..(succeed*100).."</color>");

            local show_num = r_vo.compose_consume[1][2] * index;
            local pack_num = DataCenter.packData:getItemCountById(r_vo.compose_consume[1][1]);
            if pack_num >= show_num then
                self.isHaveMoney = true;
            else
                self.isHaveMoney = r_vo.compose_consume[1][1];
            end
            local tvo = Lua_ToolVo.new(r_vo.compose_consume[1][1]);
            self.cost_icon:setAltas(tvo.atlas, tvo.sprite);
            self.cost_value.text = show_num;

        end
    else
        self.compoundVo = nil;
        self.icon_add:setEnable(true);
        self.icon_bg:setAltas("runes_atlas", "ui_fs_itembg_10");
        self.icon_bg.mouseEnable = false;
        self.icon_bg:removeClickFuntion(self, self.onCheckCompound);
        self.icon:setEnable(false);
        
        self.cost_obj:SetActive(false);
        -- self.compound_btn:setBtnEnable(false);
        self.succeed_tips:setLangValue(126822);
    end
end

function Lua_RunesCompoundWindow:onCheckCompound()
    if self.compoundVo == nil then
        return;
    end
    Lua_WindowUtil.openWin("Lua_RunesRecastSkillDesWindow", Lua_WinParam.ACTION_OPEN, self.compoundVo);
end

--选择材料返回
function Lua_RunesCompoundWindow:updateCostSelectInfo(list)
    self.selectRunesUidDic = list;
    self:updateShowCompound(list);
end

--打开材料选择界面
function Lua_RunesCompoundWindow:onCompoundCostWindow()
    Lua_WindowUtil.openWin("Lua_RunesCompoundCostWindow", Lua_WinParam.ACTION_OPEN, self.selectRunesUidDic);
end

--一键选择数量
function Lua_RunesCompoundWindow:updatePutNum(val)
    DataCenter.runesData.showPutNum = val;
    self.sub:setGray(val <= DataCenter.runesUtil.put_runes_min);
    self.add:setGray(val >= DataCenter.runesUtil.put_runes_max);
    self.num.text = val;
end

function Lua_RunesCompoundWindow:onSubBtnClick()
    self.showPutNum = self.showPutNum -1;
    if self.showPutNum < DataCenter.runesUtil.put_runes_min then
        self.showPutNum = DataCenter.runesUtil.put_runes_min;
    end
    
    self:updatePutNum(self.showPutNum);
end

function Lua_RunesCompoundWindow:onAddBtnClick()
    self.showPutNum = self.showPutNum +1;
    if self.showPutNum > DataCenter.runesUtil.put_runes_max then
        self.showPutNum = DataCenter.runesUtil.put_runes_max;
    end
    self:updatePutNum(self.showPutNum)
end

function Lua_RunesCompoundWindow:onHelpClick()
    local param = { des = LanUtil.getValue(126845), posX = 175, posY = -300 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_RunesCompoundWindow:onShowSkillBtnClick()
    Lua_WindowUtil.openWin("Lua_RunesSkillShowWindow", Lua_WinParam.ACTION_OPEN, 1);
end

function Lua_RunesCompoundWindow:onSmeltBtnClick()
    Lua_WindowUtil.openWin("Lua_RunesSmeltRewardWindow", Lua_WinParam.ACTION_OPEN);
end

--一键添加
function Lua_RunesCompoundWindow:onOneAddBtnClick()
    self.selectRunesUidDic,isBool = DataCenter.runesData:getOneSelectCostDic(self.showPutNum);
    --print(self.showPutNum,"= = 一键添加 = =",isBool)
    if isBool == false then
        OperateAlert.showLangValue(126825);
        Lua_WindowUtil.openWin("Lua_RunesCompoundCostWindow", Lua_WinParam.ACTION_OPEN, self.selectRunesUidDic);
    end
    self:updateShowCompound(self.selectRunesUidDic);
end

--合成
function Lua_RunesCompoundWindow:onCompoundBtnClick()
    local select_num = 0;
    for k,v in pairs(self.selectRunesUidDic) do
        if v == 1 then
            select_num = select_num +1;
        end
    end
    if select_num == 0 then
        OperateAlert.showLangValue(126820);
        return
    end
    if select_num < DataCenter.runesUtil.put_runes_min then
        OperateAlert.showLangValue(126821);
        return
    end
    if self.isHaveMoney ~= nil and self.isHaveMoney ~= true then --钱不够
        DataCenter.packUtil:openPathWindow(self.isHaveMoney, false);
        return;
    end
    Lua_ProxyManager.getProxy("Lua_RunesProxy"):sCompoundRunes(self.selectRunesUidDic);
end




















Lua_RunesCompoundItem = class("Lua_RunesCompoundItem", Lua_DisplayObject);
function Lua_RunesCompoundItem:ctor(p)
    self:superCall("ctor", p, "RunesCompoundItem_skin");
end

function Lua_RunesCompoundItem:buildShowItem()
    self:superCall("buildShowItem");

    self.bg:addClickFuntion(self, self.onBtnClick);
end

function Lua_RunesCompoundItem:setData(uid)
    if uid == nil then
        self.data = nil;
        self.add:setEnable(true);
        self.icon:setEnable(false);
        self.show:setEnable(false);
    else
        self.add:setEnable(false);
        self.icon:setEnable(true);
        self.show:setEnable(true);
        self.data = DataCenter.runesData:getRunesVoByUid(uid);
        self.icon:setAltas(self.data.atlas, self.data.sprite);
    end
end

function Lua_RunesCompoundItem:onBtnClick()
    -- if self.data == nil then
        Lua_MsgUtil.callFunc("ON_SELECT_COMPOUND_ITEM");
    -- else
    --     DataCenter.packUtil:showItemInfo(self.data);
    -- end
end

function Lua_RunesCompoundItem:dispose()
    self.data = nil;
    self:superCall("dispose");
end