--符石技能展示
Lua_RunesSkillShowWindow = class("Lua_RunesSkillShowWindow", Lua_Window);
function Lua_RunesSkillShowWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_RunesSkillShowWindow";
    self.skinName = "RunesSkillShowWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_RunesSkillShowWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.dragList = Lua_DragList.new(self.content, 610, 680, Lua_AxisDefine.Vertical);
    self.dragList:setLocation(0, -35);
    self.dragList:setListCell(Lua_RunesSkillShowCell, 114, 140, 5);
    self.dragList:setCellSpacing(10, 13);
    
    self.btnInfo = Array();
    self.btnInfo:add({ textStr = LanUtil.getValue(126846), level = 1 });
    self.btnInfo:add({ textStr = LanUtil.getValue(126847), level = 2 });
    self.btnInfo:add({ textStr = LanUtil.getValue(126848), level = 3 });
    -- self.btnInfo:add({ textStr = LanUtil.getValue(126849), level = 4 });

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.btnList:setLocation(0, -433, 0);
    self.btnList:setButtonStyle("common_altas_1", "ui_common_tab_02", "ui_common_tab_02", 232, 71, 0.01, 1);
    self.btnList:setButtonText(1, 6, "5C504B", "8B5E34", 30, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.btnList:setButtonLine("common_altas_1", "ui_common_line_013", 0, 0, 0, -6);
    self.btnList:setRedPoint(50, 25);
    self.btnList:setButtonItem(222, 71);
    self.btnList:setClickCallBack(self, self.onTabBtnClick);
    self.btnList:setData(self.btnInfo);

    self.checkHelp:addClickFuntion(self, self.onCheckHelp);
end

function Lua_RunesSkillShowWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    if self.btnList ~= nil then
        self.btnList:dispose();
        self.btnList = nil;
    end
    if self.btnInfo ~= nil then
        self.btnInfo:dispose();
        self.btnInfo:clear();
        self.btnInfo = nil;
    end
    self:superCall("dispose");
end

function Lua_RunesSkillShowWindow:showWin(param)
  	if param > 4 then
  		self.btnList:setSelected(3);
  	else
  		self.btnList:setSelected(1);
  	end
end

function Lua_RunesSkillShowWindow:onTabBtnClick(val)
    if self.selectTabIndex == val then
        return;
    end
    self.selectTabIndex = val;
    local level = self.btnInfo[val].level;
    local arr = DataCenter.runesUtil:getRunesSkillInfoByLevel(level);
    self.dragList:setArrayData(arr);
end

function Lua_RunesSkillShowWindow:onCheckHelp(go)
    local tipsData = { needAdapt = false, des = LanUtil.getValue(126850), posX = -35, posY = 370 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end














Lua_RunesSkillShowCell = class("Lua_RunesSkillShowCell", Lua_ListCell);
function Lua_RunesSkillShowCell:ctor(p)
    self:superCall("ctor", p,"RunesSkillShowCell_skin");
end

function Lua_RunesSkillShowCell:buildShowItem()
    self:superCall("buildShowItem");
    self.skill_icon = Lua_SkillIconItem.new(self.content);
    self.skill_icon:setLocation(0,15,0);
end

function Lua_RunesSkillShowCell:setData(data)
    self.skill_vo = Lua_SkillConfigData.getConfigData(data.id);
    self.skill_icon:setData(self.skill_vo);
    self.skill_icon:setRarityIcon(self.skill_vo.rarity);
    self.skill_name.text = self.skill_vo.name;
end

function Lua_RunesSkillShowCell:dispose()
    if self.skill_icon ~= nil then
        self.skill_icon:dispose() 
        self.skill_icon = nil;
    end
    self.skill_vo = nil;
    self:superCall("dispose");
end

function Lua_RunesSkillShowCell:onPressClick()
    if self.skill_vo == nil then
        return;
    end
    Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.skill_vo);
end