--符石tips
Lua_RunesTipsWindow = class("Lua_RunesTipsWindow", Lua_Window);
function Lua_RunesTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RunesTipsWindow";
	self.skinName = "RunesTipsWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_RunesTipsWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.itemIcon = UICreate.createUIAtlasImage(self.content, nil, nil, -196, 284, 101, 101);
    self.itemIcon:setScale(0.8, 0.8, 0.8);

    self.checkHelp:addClickFuntion(self, self.onCheckHelp);
    self.skillView:addClickFuntion(self, self.onSkillView);
end

function Lua_RunesTipsWindow:dispose()
    if self.attrArr ~= nil then
        self.attrArr:dispose();
        self.attrArr:clear();
        self.attrArr = nil;
    end
    if self.skillArr ~= nil then
        self.skillArr:dispose();
        self.skillArr:clear();
        self.skillArr = nil;
    end
    if self.btnArr ~= nil then
        self.btnArr:dispose();
        self.btnArr:clear();
        self.btnArr = nil;
    end   
    self.data = nil;
    self:superCall("dispose");
end

function Lua_RunesTipsWindow:showWin(param)
	self:superCall("showWin", param);
	self.data = param.data;
	self.isShowBtns = param.isShowBtns;
	self.part = param.part;
	self.hero_uid = param.hero_uid;

	self.winBg:setAltas("common_altas_2", "ui_common_window_0"..(self.data.color + 16));
	self.itemIcon:setAltas(self.data.atlas, self.data.sprite);
	self.nameText.text = self.data.name;
	self.scoreText.text = LanUtil.formateStr(309030, tostring(self.data.score));

	local show_h = 215;--固定高度
	self.add_h = 0;
	self:showBaseAttr(self.data.cur_prop);-- 属性
	self:showSkill(self.data.rune_skill_list);--技能
	--按钮
	if param.isShowBtns == false then
		self.btnObject:SetActive(false);
		self:showButtonList(nil);
	else
		self.btnObject:SetActive(true);
		self:showButtonList(self.data.buttonList); -- 按钮增加的高度
	end
	self.winBg:SetDimensions(544, show_h + self.add_h + 25);
end

-- 基础属性
function Lua_RunesTipsWindow:showBaseAttr(list)
	if self.attrArr == nil then
		self.attrArr = Array();
	end

	local arr = DataCenter.attributesUtil:getAttrArrByServer(list);
	local len = arr:getSize()
	local item;
	local posX;
	local posY;
	for i = 1, len do
		item = self.attrArr[i];
		if item == nil then
			item = Lua_RunesTipsAttrItem.new(self.attrObject);
			self.attrArr:add(item);
		end
        posX = -235 + ((i - 1) % 2) * 480;
        posY = -45 + Mathf.Floor((i - 1) / 2) * -40;
		item:setLocation(posX, posY, 0);
		item:setData(arr[i], i % 2);
	end

	self.add_h = self.add_h + Mathf.Floor((len - 1) / 2) * 40;
end

-- 技能
function Lua_RunesTipsWindow:showSkill(list)
	if list == nil or #list == 0 then
		self.skillObject:SetActive(false);
		return;
	end
	LuaUtil.setObjPos(self.skillObject, 0, 106 - self.add_h, 0);
	self.add_h = self.add_h + 55;--技能标题宽度/间距
	self.skillObject:SetActive(true);

	if self.skillArr == nil then
		self.skillArr = Array();
	end
	local h = 98;
	local off_h = 0;
	local item;
	for i = 1, #list do
		item = Lua_RunesTipsSkillItem.new(self.skillObject);
		item:setData(list[i]);

		local space = i == 1 and 0 or 20;--间距
		item:setLocation(0, -85 - (i-1)*h - off_h - space, 0);
		off_h = item.off_h;
		self.add_h = self.add_h + h + off_h + space;
		self.skillArr:add(item);
	end
end

function Lua_RunesTipsWindow:showButtonList(list)
	if list == nil then
		return;
	end
    if self.btnArr == nil then
        self.btnArr = Array();
    end
    local arr = Array();
    local obj;
	if list ~= nil then
	    for i = 1, #list do
	        obj = list[i];
	        if self.data.expired_tick ~= nil and self.data.expired_tick > 0 then
	            if self.data.isExpired then
	                if obj == 4 then
	                    arr:add(obj);
	                end
	            else
	                if obj ~= 4 then
	                    arr:add(obj);
	                end
	            end
	        else
	            arr:add(obj);
	        end
	    end
	end

    local num = arr:getSize();
    local len = self.btnArr:getSize();
    local maxLen = num > len and num or len;
    local btn;

    local startX;
    local intervalX;
    local intervalY = -66;
    local count;
    if num == 1 then
        startX = 0;
        intervalX = 0;
        count = 1;
    elseif num == 2 then
        startX = -138;
        intervalX = 276;
        count = 2;
    elseif num == 3 then
        startX = -172;
        intervalX = 172;
        count = 3;
    elseif num == 4 then
        startX = -138;
        intervalX = 276;
        count = 2;
    elseif num == 5 then
        startX = -172;
        intervalX = 172;
        count = 3;
    elseif num == 6 then
        startX = -172;
        intervalX = 172;
        count = 3;
    end    

    local posX;
    local posY;
    for i = 1, maxLen do
        btn = self.btnArr[i];
        if i > num then
            if btn ~= nil then
                btn:setEnable(false);
            end
        else
            if btn == nil then
                btn = UICreate.createButton(self.btnObject, nil, 0, 0, 156, 51);
                btn:setStyle(11);
                btn.txt:setLocation(0, 0, 0);
                btn.txt.fontSize = 27;
                btn.txt.colorStr = Lua_ColorDefine.transColorStr("3D424F");
                self.btnArr:add(btn);
            else
                btn:setEnable(true);
            end
            
			if self.part == nil then
	            btn:setLangValue(309010 + arr[i]);
	        else
	        	if arr[i] == 3 then
	        		btn:setLangValue(309066);
	        	elseif arr[i] == 6 then
	        		btn:setLangValue(309065);
	        	else
	        		btn:setLangValue(309010 + arr[i]);
	        	end
			end
			btn.name = tostring(arr[i]);
            posX = startX + ((i - 1) % count) * intervalX;
            posY = -55 + Mathf.Floor((i - 1) / count) * intervalY;
            if num == 5 and i == num then
                posX = posX + intervalX;
            end
            btn:setLocation(posX, posY, 0);
            btn:addClickFuntion(self, self.onButtonClick);
        end
    end

    LuaUtil.setObjPos(self.btnObject, 0, 106 - self.add_h, 0);
    self.add_h = self.add_h + 19;
    if num < 4 then
        self.add_h = self.add_h + 77;
	else
		self.add_h = self.add_h + 145;
    end
end

function Lua_RunesTipsWindow:onButtonClick(go)
	if tonumber(go.name) == 2 then -- 合成
		Lua_WindowUtil.openWin("Lua_RunesCompoundWindow", Lua_WinParam.ACTION_OPEN);
	elseif tonumber(go.name) == 3 then
		if self.part == nil then
			-- 分解
			local str = spliceIconStrById(self.data.decompose[1][1])..tostring(self.data.decompose[1][2]);
			local param = { des = LanUtil.formateStr(126852, str), btnType = 1, owner = self, sureFun = self.onDecompose };
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, param);
		else
			Lua_ProxyManager.getProxy("Lua_RunesProxy"):sDemountRunes(self.hero_uid, self.part); -- 卸下
			self:hide();
		end
	elseif tonumber(go.name) == 6 then
		if self.part == nil then
			DataCenter.funcPathUtil:gotoFunction(1033, true);
		else
			Lua_WindowUtil.openWin("Lua_RunesChangeWindow", Lua_WinParam.ACTION_OPEN, { part = self.part, hero_uid = self.hero_uid, data = self.data }); -- 替换
		end
	elseif tonumber(go.name) == 7 then -- 重铸
		Lua_WindowUtil.openWin("Lua_RunesRecastWindow", Lua_WinParam.ACTION_OPEN, self.data);
	end
end

function Lua_RunesTipsWindow:onDecompose()
    local dic = {};
    dic[self.data.unique_id] = 1;
    Lua_ProxyManager.getProxy("Lua_RunesProxy"):sDecomposeRunes(dic);
    self:hide();
end

function Lua_RunesTipsWindow:onCheckHelp(go)
	local param = { des = LanUtil.getValue(126831), posX = 120, posY = 312, needAdapt = false };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, param);
end

--技能总览
function Lua_RunesTipsWindow:onSkillView(go)
	Lua_WindowUtil.openWin("Lua_RunesSkillShowWindow", Lua_WinParam.ACTION_OPEN, self.data.color);
end




















Lua_RunesTipsAttrItem = class("Lua_RunesTipsAttrItem", Lua_DisplayObject);
function Lua_RunesTipsAttrItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_RunesTipsAttrItem:buildShowItem()
	self:superCall("buildShowItem");

	self.attr_icon = UICreate.createUIAtlasImage(self.content, "common_altas_2", "ui_sq_icon_13", 0, 0, 0, 0);
	self.attr_text = UICreate.createLabel(self.content, "", 0, 0, 100, 31, 22);
	self.attr_text.horizontalOverflowValue = 1;
end

function Lua_RunesTipsAttrItem:dispose()
	self:superCall("dispose");
end

function Lua_RunesTipsAttrItem:setData(attrVo, value)
	self.attr_icon:setAltas("common_altas_2", attrVo.attr_icon_2);
	local tab = { attrVo.show_name, "：", "<color=#37D652>", attrVo.showValue, "</color>" };
	self.attr_text.text = table.concat( tab, "" );

	if value == 0 then -- 右
		self.attr_text.pivot = Lua_WindowUtil.getPivot(5);
		self.attr_text.alignmentValue = 5;

		self.attr_icon.pivot = Lua_WindowUtil.getPivot(5);
		self.attr_text:resetSize();
		self.attr_icon:setLocation(-(self.attr_text.width + 15), 0, 0);
	else -- 左
		self.attr_icon.pivot = Lua_WindowUtil.getPivot(3);
		self.attr_text.pivot = Lua_WindowUtil.getPivot(3);
		self.attr_text.alignmentValue = 3;
		self.attr_text:setLocation(self.attr_icon.width + 15, 0, 0);
	end
end























Lua_RunesTipsSkillItem = class("Lua_RunesTipsSkillItem", Lua_DisplayObject);
function Lua_RunesTipsSkillItem:ctor(p)
	self:superCall("ctor", p, "RunesSkillTipsItem_skin");
end

function Lua_RunesTipsSkillItem:buildShowItem()
	self:superCall("buildShowItem");
	self.skill_icon:addClickFuntion(self, self.onBtnClick)
end

function Lua_RunesTipsSkillItem:dispose()
	self.skillVo = nil;
	self:superCall("dispose");
end

function Lua_RunesTipsSkillItem:setData(id)
	self.skillVo = Lua_SkillConfigData.getConfigData(id);
	self.skill_icon:setAltas(self.skillVo.atlas, self.skillVo.sprite);
	self.skill_name.text = self.skillVo.name;
	self.skill_des.text = self.skillVo.des;
	self.skill_des:resetSize();
end

function Lua_RunesTipsSkillItem.Get:off_h()
	local w = self.skill_des.height > 52 and self.skill_des.height-55 or 0;
	return w;
end

function Lua_RunesTipsSkillItem:onBtnClick()
	if self.skillVo == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.skillVo);
end